# List Webhook Events

**`GET /webhooks/:webhookId/events`**

Lists all events for a given webhook.&#x20;

{% hint style="info" %}

* Request headers required. See [Request Headers](/d/advanced-topics/authentication/request-headers.md) for more information.
* Authentication required. See [Authentication Headers](/d/advanced-topics/authentication/request-headers.md#authentication-headers) for more information.
  {% endhint %}

{% hint style="warning" %}
We only keep a trace of those Webhook Events in our system for a **retention period of 31 days**. Past that, they are discarded, so you cannot see them using [List Webhook Events](/d/api-docs/webhooks/list-webhook-events.md) or [Get Webhook Event](/d/api-docs/webhooks/get-webhook-event.md) endpoints.
{% endhint %}

### Permissions Required

* `Webhooks:Events:Read`

## Request Params

The following query parameters can be appended to the url

<table data-full-width="true"><thead><tr><th width="169.33333333333331">Property</th><th width="193">Type</th><th>Description</th></tr></thead><tbody><tr><td>deliveryFailed</td><td>Boolean - Optional</td><td>If this query parameter is not specified, all Webhook Events will be returned (whether their delivery failed or not). If you pass <code>deliveryFailed=true</code> , only the webhook events which delivery failed are returned. If you pass  <code>deliveryFailed=false</code> only the events which delivery succeeded are returned. (more details <a href="/pages/rYjtWyHs7nivyQhPbpVj#webhook-event-deliveries-and-retries">here</a>)</td></tr><tr><td>limit</td><td>Number - Optional</td><td>Maximum number of items included in response</td></tr><tr><td>paginationToken</td><td>String - Optional</td><td>Page cursor used (taken from the previous response <code>nextPageToken</code>).</td></tr></tbody></table>

## Response

See [Webhook Event Data](https://docs.dfns.co/d/api-docs/webhooks#event-data) for more details on potential response formats by webhook event kind.

```json
{
  "items": [
    {
      "id": "wh-xxx-xxxxxxx",
      "kind": "wallet.transfer.confirmed",
      "date": "2023-12-04T10:02:22.280Z",     
      "deliveryFailed": false,
      "deliveryAttempt": 1,
      "timestampSent": 1701684144,
      "status": "200",
      "data": {
        ... // content depending on the kind of events it is
      },
    },
    ...
  ],
  "nextPageToken": "eJxNy8...."
}
```

<table data-full-width="true"><thead><tr><th width="177.33333333333331">Property</th><th width="193">Type</th><th>Description</th></tr></thead><tbody><tr><td>items</td><td>List of Objects</td><td>List of Webhook Event objects as detailed in the <a href="/pages/7jufUpNQJ2tW3FFpNhW7#response">Get Webhook Event</a> endpoint.</td></tr><tr><td>nextPageToken</td><td>String - Optional</td><td>Page cursor used (taken from the previous response <code>nextPageToken</code>). Will not be set if this is last page.</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs-legacy.dfns.co/d/api-docs/webhooks/list-webhook-events.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
